import tkinter as tk
from chatbot import Chatbot
from city_database import CityDatabase

API_KEY = "API_KEY"

CSV_PATH = "worldcities.csv"

city_database = CityDatabase(CSV_PATH)

chatbot = Chatbot(API_KEY, city_database)


def get_response():
    user_input = user_entry.get().strip()
    if user_input.lower() == "exit":
        root.destroy()
        return

    response = chatbot.get_response(user_input)

    chat_log.insert(tk.END, f"You: {user_input}\n")
    chat_log.insert(tk.END, f"Chatbot: {response}\n\n")
    user_entry.delete(0, tk.END)


root = tk.Tk()
root.title("Weather Chatbot")
root.geometry("500x600")

chat_log = tk.Text(root, bg="white", fg="black", font=("Arial", 12), wrap=tk.WORD)
chat_log.pack(padx=10, pady=10, fill=tk.BOTH, expand=True)

user_entry = tk.Entry(root, bg="white", fg="black", font=("Arial", 14))
user_entry.pack(padx=10, pady=5, fill=tk.X)

send_button = tk.Button(root, text="Send", bg="blue", fg="white", font=("Arial", 14), command=get_response)
send_button.pack(padx=10, pady=5)

root.mainloop()
