import pandas as pd
from thefuzz import process, fuzz

class CityDatabase:
    def __init__(self, csv_path):
        try:
            self.city_data = pd.read_csv(csv_path)
            self.cities = self.city_data['city_ascii'].tolist()
            print(f"Loaded {len(self.cities)} cities from {csv_path}.")
        except Exception as e:
            print(f"Error loading CSV: {e}")
            self.cities = []

    def correct_city(self, user_input):
        """
        Dopasowuje nazwę miasta do listy miast w bazie danych.
        """
        if not self.cities:
            return None
        print(f"User input for city matching: {user_input}")
        match = process.extractOne(user_input, self.cities, scorer=fuzz.token_set_ratio)
        if match:
            print(f"Best match: {match[0]} with score {match[1]}")
        if match and match[1] > 70:
            return match[0]
        return None


