from thefuzz import process


class IntentRecognizer:
    def __init__(self):
        self.intents = {
            "greeting": ["hello", "hi", "hey", "good morning", "good evening"],
            "farewell": ["bye", "goodbye", "see you", "later", "exit"],
            "how_are_you": ["how are you", "how are you doing"],
            "weather": ["weather in", "what's the weather", "tell me the weather", "tell me what's the weather",
                        "weather"],
            "help": ["help", "what can you do"]
        }

    def recognize_intent(self, user_input):
        flat_intents = [(intent, phrase) for intent, phrases in self.intents.items() for phrase in phrases]

        best_match = process.extractOne(user_input, [phrase for _, phrase in flat_intents])
        if best_match and best_match[1] > 70:
            for intent, phrase in flat_intents:
                if phrase == best_match[0]:
                    return intent
        return None
